﻿using System;
using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Core;
using HeuristicLab.Parameters;
using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;

namespace HeuristicLab.Algorithms.IteratedSymbolicExpressionConstruction {
  [StorableClass]
  [Item("TabularAvgQualityFunction", "")]
  public class TabularAvgStateValueFunction : TabularStateValueFunctionBase {

    public TabularAvgStateValueFunction()
      : base() {
    }

    #region item
    [StorableConstructor]
    protected TabularAvgStateValueFunction(bool deserializing) : base(deserializing) { }
    protected TabularAvgStateValueFunction(TabularAvgStateValueFunction original, Cloner cloner)
      : base(original, cloner) {
    }
    public override IDeepCloneable Clone(Cloner cloner) {
      return new TabularAvgStateValueFunction(this, cloner);
    }
    #endregion

    protected override double CalculateNewQ(object state, double observedQuality) {
      var delta = observedQuality - Value(state);
      return Value(state) + (1.0 / Tries(state)) * delta; // iterative calculation of mean
    }
  }
}
